---
- name: List images
  uri:
    url: "https://{{ ibmcloud_vpc_region }}.iaas.cloud.ibm.com/v1/images?version={{ ibmcloud_api_version }}&generation={{ ibmcloud_vpc_generation }}"
    method: GET
    headers:
      Authorization: "Bearer {{ ibmcloud_iam_token }}"
  register: api_output
  delegate_to: localhost

- name: Store Image ID
  vars:
    api_query: "images[?name=='{{ vps_image_name }}'].id"
  loop: "{{ api_output.json | json_query(api_query) }}"
  set_fact:
    image_id: "{{ item }}"
  delegate_to: localhost

- name: Create Instance
  uri:
    url: "https://{{ ibmcloud_vpc_region }}.iaas.cloud.ibm.com/v1/instances?version={{ ibmcloud_api_version }}&generation={{ ibmcloud_vpc_generation }}"
    method: POST
    headers:
      Authorization: "Bearer {{ ibmcloud_iam_token }}"
    body: " {\"name\":\"{{ vps_name }}\",\"profile\":{\"name\":\"{{ vps_profile }}\"},\"zone\":{\"name\":\"{{ vpc_zone }}\"},\"vpc\":{\"id\":\"{{ vpc_id }}\"},\"image\":{\"id\":\"{{ image_id }}\"},\"primary_network_interface\":{\"subnet\":{\"id\":\"{{ subnet_id }}\"}},\"keys\":[{\"id\":\"{{ ssh_key_id }}\"}]}"
    status_code: [200, 201]
  register: api_output
  delegate_to: localhost

- pause:
    prompt: "Waiting a while to let the instance create, should replace this with a loop later"
    seconds: 120
